<template>
<div class="gris">
    <div class="divBuscador">
        <div>
            <v-text-field v-model="search" class="buscador" append-icon="mdi-magnify" label="Buscar..." single-line hide-details>
            </v-text-field>
        </div>
    </div>

    <v-data-table :headers="encabezadoHallazgos" 
        :items="hallazgosFiltrados" 
        :page.sync="page" 
        :items-per-page="itemsPerPage" 
        hide-default-footer 
        @page-count="pageCount = $event" 
        :search="search" 
        class="tblGeneral tblHallazgos">

        <template v-slot:item.status="{item}">
            <div :class="{
                borderV: item.status == 3,
                borderN: item.status == 0,
                borderN__light: item.status == 2,
                borderR: item.status == 1,
                }">
                <span class="demi" v-if="item.status == 0">Rechazado por atender</span>
                <span class="demi" v-if="item.status == 1"> Por atender </span>
                <span class="demi" v-if="item.status == 2"> Por autorizar </span>
                <span class="demi" v-if="item.status == 3"> Atendido </span>
            </div>
        </template>

        <template v-slot:item.preg="{item}">
            <a class="liga" @click="getDetalleHallazgo(item)">{{ item.preg }}
            </a>
        </template>

        <template v-slot:item.criticidad="{item}">
            <a class="liga" @click="getHistoriaHallazgo(item.idHallazgo)">Ver Historial</a>
        </template>

    </v-data-table>
    <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount" class="paginador"></v-pagination>
    </div>
</div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
    props: {
        idCeco: String,
        idFase: String,
        idProyecto: String
    },
    name: "tabla-hallazgos",
    data() {
        return {
            hallazgos: [],
            hallazgosFiltrados: [],
            page: 1,
            pageCount: 1,
            itemsPerPage: 10,
            search: "",
            propiedades_footer: {
                itemsPerPageOptions: [2, 4, 5, 10],
            },
            encabezadoHallazgos: [{
                    text: "Estatus",
                    value: "status",
                    align: 'center'
                },
                {
                    text: "ID",
                    value: "idHallazgo",
                    align: 'center'
                },
                {
                    text: "Zona",
                    value: "area",
                    align: 'center'
                },
                {
                    text: "Protocolo",
                    value: "nombChek",
                    align: 'center'
                },
                {
                    text: "Item",
                    value: "preg",
                    align: 'center'
                },
                {
                    text: "Respuesta",
                    value: "respuesta",
                    align: 'center'
                },
                {
                    text: "Historial",
                    value: "criticidad",
                    align: 'center'
                },
            ]
        }
    },
    created() {
        this.getHallazgos();
    },
    methods: {
        getHallazgosFiltrados(status){

            this.hallazgosFiltrados = []

            if(status == 4){
                return this.hallazgosFiltrados = this.hallazgos
            }else{
                this.hallazgos.forEach(hallazgo => {
                if(hallazgo.status == status){
                    this.hallazgosFiltrados.push(hallazgo)
                }

                return this.hallazgosFiltrados
                })
            } 

        },
        getDetalleHallazgo(item) {
            axiosChecklist
                .get(
                    "/expansionCoreServices/getDetalleHallazgoCecoFaseProyectoId.json?idCeco=" +
                    this.idCeco +
                    "&idProyecto=" +
                    this.idProyecto +
                    "&idFase=" +
                    this.idFase +
                    "&idHallazgo=" +
                    item.idHallazgo, {
                        responseType: "json",
                    }
                )
                .then((response) => {
                    if (response) {
                        if (response.status === 200) {
                            console.log(JSON.stringify(response.data));
                            
                            router.push({
                                name: "modelo_franquicia_atencion_hallazgo_calidad",
                                params: {
                                    dataJson: response.data,
                                    hallazgos: this.hallazgos,
                                    idCeco: this.idCeco,
                                    idFase: this.idFase,
                                    idProyecto: this.idProyecto,
                                    idHallazgo: item.idHallazgo,
                                },
                            });
                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        },
        getHistoriaHallazgo(idHallazgo) {
            axiosChecklist
                .get(
                    "/expansionCoreServices/getHistorialHallazgoCore.json?idHallazgo=" +
                    idHallazgo
                )
                .then((response) => {
                    if (response) {
                        if (response.status == 200) {
                            //console.log(JSON.stringify(response.data));
                            router.push({
                                name: "modelo_franquicia_detalle_hallazgo_calidad",
                                params: {
                                    dataJson: response.data,
                                    idCeco: this.idCeco,
                                    idFase: this.idFase,
                                    idProyecto: this.idProyecto

                                },
                            });
                        }
                    }
                })
                .catch((error) => {
                    console.log("Ocurrio un error al obtener el historial del hallazgo");
                    console.log(error);
                })
                .finally((final) => {});
        },
        getHallazgos() {
            axiosChecklist
                .get(
                    "expansionCoreServices/getHallazgosExpansionCore.json?ceco=" +
                    this.idCeco +
                    "&proyecto=" +
                    this.idProyecto +
                    "&fase=" +
                    this.idFase, {
                        responseType: "json",
                    }
                )
                .then((response) => {
                    if (response) {
                        if (response.status === 200) {
                            this.hallazgos = response.data;
                            this.hallazgosFiltrados = this.hallazgos
                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        }
    },

}
</script>
